DATABASE sysadmin;
DROP FUNCTION IF EXISTS ifx_setup_json( );
CREATE FUNCTION ifx_setup_json( ) 
RETURNING INTEGER
DEFINE result  INTEGER;
DEFINE tmp     BIGINT;
DEFINE server_size     VARCHAR(32);
DEFINE space_size      INTEGER;
DEFINE ifxdir          VARCHAR(255);
DEFINE myuser          VARCHAR(255);
DEFINE json_listener   VARCHAR(64);
DEFINE cdr_queuemem_var  INTEGER;
DEFINE tmpstr          LVARCHAR(1024);
DEFINE tmpint          INTEGER;
DEFINE dbservname      VARCHAR(128);


LET ifxdir = (SELECT env_value 
FROM sysmaster:sysenv 
WHERE env_name = 'INFORMIXDIR');
-- SET DEBUG FILE TO 'informix_setup.out';
-- SET DEBUG FILE TO TRIM(ifxdir)||'/tmp/informix_setup.out';
-- SET DEBUG FILE TO '/tmp/informix_setup.out';
-- TRACE ON;

LET json_listener = 'jsonListener.properties';

---Start the Wire listener only if the property file exists. 
---Also create database user ifxjson it requires for the connection. 
---Check for non exist error on the path name
DELETE FROM ph_threshold WHERE name MATCHES 'JSON LISTENER PROP*';
LET tmp = ( SELECT count(*) 
FROM sysmaster:sysdual 
WHERE task('print file info', TRIM(ifxdir)||'/etc/'||TRIM(json_listener))
MATCHES '*Error*= 2*');
IF tmp > 0 THEN 
--- no java property file
UPDATE sysadmin:ph_task 
SET (tk_enable)=('f') 
WHERE tk_name = 'Json Listener';
ELSE
--- java property file exists
INSERT INTO ph_threshold(id,name,task_name,value,description)
VALUES
(0,'JSON LISTENER PROPERTY', 'Json Listener',
json_listener, 'JSON listener property filename.');
UPDATE sysadmin:ph_task 
SET (tk_enable)=('t') 
WHERE tk_name = 'Json Listener';
END IF;
END FUNCTION;
EXECUTE FUNCTION ifx_setup_json();

DROP FUNCTION ifx_setup_json();

CLOSE DATABASE;
